﻿var selectorsECPolicy = {
    GeneralEnabled: "#enable-endpoint-control-policy",
    SwitchService: ".ec-policy-switch-label",
    InheritFrmPrntCheckbox: "#grp-inherit-policy-ec-checkbox",
    OpenPolicyRuleCard: ".btn-open-device-rules-card.btn-add-ec-rule",
    ECPolicyRuleCard: ".ec-policy-rules-card",
    BtnClosePolicyRuleCard: ".ec-policy-rules-card a.btn-close-card",
    BtnEditPolicyRule: ".btn-open-endpoint-control-rules-card.tip-edit-role",
    MaxFileSizeSelectedType: "#maxFileSizeSelectedType",
    ECRulesTable: ".table-ec-access-rules",
    ECAddRecipients: "#notify-ec-add-rec",
    AddPolicyUserInput: "#newPolicyUserNameInput",
    AddPolicyFileTypeInput: "#newPoliceFileTypeInput",
    CardCloseButton: "#endpoint-policy-rule-card #closeEndPointControlCard",
    CardApplyDiscardButtons: "#endpoint-policy-rule-card #applyDiscardChanges-EndPointControl",
};

////////////////////// Global Variables ///////////////////////
var globalAllFileTypes = null;
var ecAlertRecipientsTagify = null;

var grpBlackListExceptionToEdit = null;
var grpBlackListExceptionToDelete = null;
var indexOfGrpBlacklistExceptionToDelete = -1;
var indexOfGrpBlacklistExceptionToEdit = -1;
var addingGrpBlacklistException = false;


var grpWhiteListExceptionToEdit = null;
var grpWhiteListExceptionToDelete = null;
var indexOfGrpWhitelistExceptionToDelete = -1;
var indexOfGrpWhitelistExceptionToEdit = -1;
var addingGrpWhitelistException = false;


function SetInheritFromParent() {
    $(selectorsECPolicy.InheritFrmPrntCheckbox).icheck("checked");
}

function UnsetInheritFromParent() {
    $(selectorsECPolicy.InheritFrmPrntCheckbox).icheck("unchecked");
}

function setMaxFileSizeDesignation(sizeDesignation) {
    var maxSizeSelected = $(selectorsECPolicy.MaxFileSizeSelectedType);

    switch (sizeDesignation) {
    case "gbs":
        maxSizeSelected.innerText = "Gbs";
        break;
    case "mbs":
        maxSizeSelected.innerText = "Mbs";
        break;
    case "kbs":
        maxSizeSelected.innerText = "Kbs";
        break;
    } 
}

function getMaxFileSizeAndSizeType(realMaxFileSize)
{
    var gbUnit = 1024 * 1024 * 1024;
    var mbUnit = 1024 * 1024;
    var kbUnit = 1024;
    var maxFileSize = 0;
    var sizeType = "";

    if (realMaxFileSize % gbUnit == 0)
    {
        maxFileSize = realMaxFileSize / gbUnit;
        sizeType = "gbs";
    }
    else if (realMaxFileSize % mbUnit == 0)
    {
        maxFileSize = realMaxFileSize / mbUnit;
        sizeType = "mbs";
    }
    else if (realMaxFileSize % kbUnit == 0)
    {
        maxFileSize = realMaxFileSize / kbUnit;
        sizeType = "kbs";
    }
    else
    {
        maxFileSize = realMaxFileSize;
        sizeType = "";
    }

    return {MaxSize: maxFileSize, SizeType: sizeType};
}

function convertMaxFileSize(sizeType, maxFileSize) {
    var gbUnit = 1024 * 1024 * 1024;
    var mbUnit = 1024 * 1024;
    var kbUnit = 1024;

    switch (sizeType) {
    case "gbs":
        maxFileSize *= gbUnit;
        break;
    case "mbs":
        maxFileSize *= mbUnit;
        break;
    case "kbs":
        maxFileSize *= kbUnit;
        break;
    }

    return maxFileSize;
}

function GetECPolicySettings(groupGuid) {
    console.log("Get EC Policy for group " + groupGuid);

    $("#prompt").off("click", selGroup.btnActivateTrial);
    $("#prompt").on("click", selGroup.btnActivateTrial, function () {
        hidePrompt();
        angularSEP.Scope[angularSEP.ControllerECGroupProtectionPolicy].Policy.RegisterTrial = true;
        enableECGroupPolicy();
    });

    $("#prompt").off("click", selGroup.btnPolicyChildAllGroups);
    $("#prompt").on("click", selGroup.btnPolicyChildAllGroups, function () {
        switchECPolicyCheck();
        angularSEP.Scope[angularSEP.ControllerECGroupProtectionPolicy].Policy.ApplyGroupPolicyEnabledToChildren = true;
        SaveGroupECSettings();
        hidePrompt();
    });

    $("#prompt").off("click", selGroup.btnPolicyThisGroupOnly);
    $("#prompt").on("click", selGroup.btnPolicyThisGroupOnly, function () {

        switchECPolicyCheck();
        angularSEP.Scope[angularSEP.ControllerECGroupProtectionPolicy].Policy.ApplyGroupPolicyEnabledToChildren = false;
        SaveGroupECSettings();
        hidePrompt();
    });

    $("#prompt").off("click", selGroup.btnConfirmExceedLicense);
    $("#prompt").on("click", selGroup.btnConfirmExceedLicense, function () {
        SaveGroupECSettingsActual();
        hidePrompt();
    });

    $("#prompt").off("click", selGroup.btnConfirmExceedLicenseCancel);
    $("#prompt").on("click", selGroup.btnConfirmExceedLicenseCancel, function () {
        switchECPolicyCheck();
        hidePageContentLoader();
    });

    GetGroupECPolicySettings(groupGuid);
}

function GetGroupECPolicySettings(groupGuid) {
    return $.ajax({
        type: 'POST',
        dataType: 'json',
        processData: false,
        async: true,
        contentType: "application/json; charset=utf-8",
        url: ActionURLS.EndPointControlPolicy.GetGroupPolicySettings,
        data: JSON.stringify({ groupGuid: groupGuid }),
        success: function (result) {

            if (HandleResult(result, "GetGroupECPolicySettings", "content", "critical", result.ErrorMsg)) {

                var policy = result.Policy;

                if (policy != null) {
                    console.log("EC Policy data retrieved");
                    overrideAndHideShowSaveMsg = true;
                    $(".tab-endpoint-control").show();

                    if (policy.Enabled)
                        turnOnSwitch(selectorsECPolicy.GeneralEnabled);
                    else
                        turnOffSwitch(selectorsECPolicy.GeneralEnabled);

                    // Set all file types to global variable because it will be used by prompt overlay
                    globalAllFileTypes = result.Policy.AllFileTypes;

                    setupControllerECGroupProtectionPolicy(angularSEP.Scope[angularSEP.ControllerECGroupProtectionPolicy], result.Policy, groupGuid);
                    angularSEP.Scope[angularSEP.ControllerECGroupProtectionPolicy].$apply();

                    if (result.Policy.InheritFromParent) {
                        SetInheritFromParent();
                    }
                    else {
                        UnsetInheritFromParent();
                    }

                    overrideAndHideShowSaveMsg = false;
                }
                else {
                    showUiMsg("card", "critical", ECPolicyStr.ECPolicyDataCouldNotBeLoaded, "", "");
                    console && console.log("GetECPolicySettings failed: no policy retreived.");
                }
            }
        },
        error: function (xhr, ajaxOptions, thrownError) {
            if (xhr.statusText == "abort")
                return;

            HandleAjaxError(xhr,
                ajaxOptions,
                thrownError,
                "content",
                "GetECPolicySettings",
                ECPolicyStr.ECPolicyDataCouldNotBeLoaded);
        }
    });
}

function SaveGroupECSettingsActual() {
    console.log("SaveGroupECSettingsActual()>>");

    try {
        var $scope = angularSEP.Scope[angularSEP.ControllerECGroupProtectionPolicy];
        var ecPolicyModel = $scope.Policy;

        // Don't return it back to server, because it is not used there. It is only for client side.
        ecPolicyModel.AllFileTypes = null;

        var grpGuid = $(SelGrpPMSettingsIds.LoadedGuid).val();

        $.ajax({
            type: 'POST',
            dataType: 'json',
            processData: false,
            async: true,
            contentType: "application/json; charset=utf-8",
            url: ActionURLS.EndPointControlPolicy.SaveGroupPolicySettings + QSHandlesJSONFail,
            data: JSON.stringify({
                grpGuid: grpGuid,
                ecPolicyModel: ecPolicyModel
            }),
            success: function (result) {

                if (HandleResult(result, "SaveGroupECSettingsActual", "content", "critical", result.ErrorMsg, null, function () {
                    hidePageContentLoader();
                    stopProbagation(event);
                })) {
                    hidePageContentLoader();
                    closeAllUiMsgs();
                    showUiMsg("card", "success", promptsStrings.ptcSaveGroupSettings, "", "", "", UISettings.MsgTimeToLiveMs);
                }
            },
            error: function (xhr, ajaxOptions, thrownError) {
                console && console.log("SaveGroupECSettingsActual failed: " + thrownError);
                hidePageContentLoader();

                if ((xhr.responseJSON.ErrorMsg == null) || (xhr.responseJSON.ErrorMsg.trim() == ""))
                    showUiMsg("card", "critical", thrownError.message, "", "", "", UISettings.MsgTimeToLiveMs);
                else
                    showUiMsg("card", "critical", xhr.responseJSON.ErrorMsg, "", "", "", UISettings.MsgTimeToLiveMs);

                stopProbagation(event);
            }
        });
    }
    catch (err) {
        console && console.log("SaveGroupECSettingsActual failed: " + err);
        hidePageContentLoader();
        showUiMsg("card", "critical", err.message, "", "", "", UISettings.MsgTimeToLiveMs);

        stopProbagation(event);
    }

    console.log("SaveGroupECSettingsActual()<<");
}

// This function will first check the license of the service and the number of group
// and devices not to exceed license count. If license check is successfull then it will
// call SaveGroupECSettingsActual to save the setttings.
function SaveGroupECSettings() {
    console.log("SaveGroupECSettings()>>");

    try {
        var $scope = angularSEP.Scope[angularSEP.ControllerECGroupProtectionPolicy];
        var ecPolicyModel = $scope.Policy;

        var grpGuid = $(SelGrpPMSettingsIds.LoadedGuid).val();

        showPageContentLoader();

        if (ecPolicyModel.Enabled) {

            var groupsGuid = new Array();

            if (ecPolicyModel.ApplyGroupPolicyEnabledToChildren)
                groupsGuid = ecPolicyModel.ChildGroupGuids;

            groupsGuid[groupsGuid.length] = grpGuid;

            // Check if exceeding license
            $.ajax({
                type: 'POST',
                dataType: 'json',
                processData: false,
                async: true,
                contentType: "application/json; charset=utf-8",
                url: ActionURLS.EndPointControlPolicy.ExceedLicenseCheck + QSHandlesJSONFail,
                data: JSON.stringify({ groupGuids: groupsGuid }),
                success: function (result) {

                    if (HandleResult(result, "SaveGroupECSettings", "content", "critical", result.ErrorMsg, null, null)) {
                        if (result.Exceeds) {
                            showPrompt('prm-exceed-license');
                        } else {
                            SaveGroupECSettingsActual();
                        }
                    }
                },
                error: function (xhr, ajaxOptions, thrownError) {
                    console && console.log("SaveGroupECSettings failed: " + thrownError);
                    hidePageContentLoader();

                    if ((xhr.responseJSON.ErrorMsg == null) || (xhr.responseJSON.ErrorMsg.trim() == ""))
                        showUiMsg("card", "critical", thrownError.message, "", "", "", UISettings.MsgTimeToLiveMs);
                    else
                        showUiMsg("card", "critical", xhr.responseJSON.ErrorMsg, "", "", "", UISettings.MsgTimeToLiveMs);

                    stopProbagation(event);
                    return false;
                }
            });
        } else {

            // Skip if exceed license since we are switching off service
            SaveGroupECSettingsActual();
        }
    }
    catch (err) {
        console && console.log("SaveGroupECSettings failed: " + err);
        hidePageContentLoader();
        showUiMsg("card", "critical", err.message, "", "", "", UISettings.MsgTimeToLiveMs);

        stopProbagation(event);
        return false;
    }

    console.log("SaveGroupECSettings()<<");
    return true;
}

function enableECGroupPolicy() {
    if (angularSEP.Scope[angularSEP.ControllerECGroupProtectionPolicy].Policy.ChildGroupGuids.length > 0)
        showPrompt('prm-policy-child-groups', ["{{SERVICENAME}}", "{{ENABLE-DISABLE}}", "{{ENABLING-DISABLING}}", "{{ENABLING-DISABLING2}}"], [ManageDevicesGeneral.EcName, ManageDevicesGeneral.Enable, ManageDevicesGeneral.Enabling, ManageDevicesGeneral.Enabling]);
    else {
        showSaveMsg("content", selSet.saveSettPatchMgmtId, null, SaveGroupECSettings);
        switchECPolicyCheck();
    }
}

function switchECPolicyCheck() {
    if ($(selectorsECPolicy.GeneralEnabled).is(":checked")) {
        turnOffSwitch(selectorsECPolicy.GeneralEnabled);

        angularSEP.Scope[angularSEP.ControllerECGroupProtectionPolicy].Policy.Enabled = false;
        angularSEP.Scope[angularSEP.ControllerECGroupProtectionPolicy].$apply();
    }
    else {
        turnOnSwitch(selectorsECPolicy.GeneralEnabled);

        angularSEP.Scope[angularSEP.ControllerECGroupProtectionPolicy].Policy.Enabled = true;
        angularSEP.Scope[angularSEP.ControllerECGroupProtectionPolicy].$apply();
    }
}

////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////// Import and Export Policy and Exception ////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////

function onECPolicyImportFileClick(event) {
    event.stopPropagation();
}

function openImportFileDialog(type) {
    switch (type) {
        case 'policy-settings':
            $("#ec-policy-userImportFile").click();
            break;
        case 'custom-blacklist':
            $("#importCustomBlacklistFile").click();
            break;
        case 'custom-whitelist':
            $("#importCustomWhitelistFile").click();
            break;
    }
}

function importEndPointControlPolicy() {
    try {
        if ($(selPrompts.saveCatchTrigger).length > 0) {
            // Save settings message is visible. The user should save settings before importing new policy.
            showPrompt("prm-import-err-pending-save");

            $("#prompt .btn-conf-import-policy").off("click");
            $("#prompt .btn-conf-import-policy").on("click", function () {
                hidePrompt();
                $("#prompt .btn-conf-import-policy").off("click");
            });

            return false;
        }

        //Skip processing for the second time calling this method. Only problem with IE 11      
        if ($("#ec-policy-userImportFile").val().length == 0) { return; }
        showPageContentLoader();

        var groupGuid = angularSEP.Scope[angularSEP.ControllerECGroupProtectionPolicy].GroupGuid;

        var formData = new FormData(this);
        formData.append("userImportFile", $("#ec-policy-userImportFile")[0].files[0]);
        formData.append("groupGuid", groupGuid);

        $.ajax({
            url: ActionURLS.EndPointControlPolicy.ImportGroupPolicySettings + QSHandlesJSONFail,
            type: 'POST',
            data: formData,
            processData: false,
            contentType: false,
            success: function (data, textStatus, jqXHR) {
                if (data != null && data.Success == "OK")
                {
                    showUiMsg("card", "info", promptsStrings.ptcImportPolicy, "", "", "", UISettings.MsgTimeToLiveMs);
                    GetECPolicySettings(groupGuid);
                }
                else
                {
                    showUiMsg("card", "critical", promptsStrings.importPolicyFailedMessage, "", "");
                    console.log("ImportEndPointControlPolicy failed: " + (data ? data.ErrorMsg : "undefined"));
                }

                $("#ec-policy-userImportFile").val("");
                hidePageContentLoader();
            },
            error: function (xhr, ajaxOptions, thrownError) {
                showUiMsg("card", "critical", promptsStrings.importPolicyFailedMessage);

                $("#ec-policy-userImportFile").val("");
                hidePageContentLoader();

                console.log("ImportEndPointControlPolicy failed: " + thrownError);
            },
            processData: false,
            async: true
        });
    }
    catch (err) {
        showUiMsg("card", "critical", promptsStrings.importPolicyFailedMessage);
        hidePageContentLoader();

        console.log("ImportEndPointControlPolicy failed: " + err);
    }


    return false;
}

function exportCustomExceptionList(inputElement, isBlacklist) {
    var groupGuid = angularSEP.Scope[angularSEP.ControllerECGroupProtectionPolicy].GroupGuid;
    var $scope = angularSEP.Scope[angularSEP.ControllerECGroupPolicyRule];
    var exceptionList = isBlacklist ? $scope.BlacklistExceptions : $scope.WhitelistExceptions;

    $.ajax({
        type: 'POST',
        dataType: 'json',
        processData: false,
        async: true,
        contentType: "application/json; charset=utf-8",
        url: ActionURLS.EndPointControlPolicy.SavePolicyRuleCustomExceptionsToTempFile,
        data: JSON.stringify({ customExceptions: exceptionList, groupGuid: groupGuid }),
        success: function (result) {
            if (result.Success === 'OK') {
                downloadURL(ActionURLS.EndPointControlPolicy.DownloadPolicyRuleCustomExceptions +
                    "?groupGuid=" +
                    groupGuid +
                    "&downloadBlacklist=" +
                    isBlacklist);
            }
            else {
                showUiMsg("card", "critical", promptsStrings.exportCustomExceptionListFailed, "", "");
                console.log("exportCustomExceptionList failed: " + (result ? result.ErrorMsg : "undefined"));
            }
        },
        error: function (xhr, ajaxOptions, thrownError) {
            showUiMsg("card", "critical", promptsStrings.exportCustomExceptionListFailed, "", "");
            console.log("exportCustomExceptionList failed: " + thrownError);
        }
    });
}

function importCustomExceptionList(inputElement, isBlacklist) {
    try {

        if ($(selPrompts.saveCatchTrigger).length > 0) {
            // Save settings message is visible. The user should save settings before importing new policy.
            showPrompt("prm-import-err-pending-save");

            $("#prompt .btn-conf-import-policy").off("click");
            $("#prompt .btn-conf-import-policy").on("click", function () {
                hidePrompt();
                $("#prompt .btn-conf-import-policy").off("click");
            });

            return false;
        }

        var grpGuid = angularSEP.Scope[angularSEP.ControllerECGroupProtectionPolicy].GroupGuid;
        var policyGuid = $(inputElement).attr("data-policy-guid");

        showPageContentLoader();

        var formData = new FormData(this);
        formData.append("userImportFile", isBlacklist ? $("#importCustomBlacklistFile")[0].files[0] : $("#importCustomWhitelistFile")[0].files[0]);
        formData.append("groupGuid", grpGuid);
        formData.append("policyGuid", policyGuid);
        formData.append("importBlacklist", isBlacklist);

        $.ajax({
            url: ActionURLS.EndPointControlPolicy.ImportPolicyRuleCustomExceptions + QSHandlesJSONFail,
            type: 'POST',
            data: formData,
            processData: false,
            contentType: false,
            processData: false,
            async: true,
            success: function (data, textStatus, jqXHR) {
                if (data != null && data.Success == "OK")
                {
                    var ctrlName = angularSEP.ControllerECGroupPolicyRule;
                    var $scope = angularSEP.Scope[ctrlName];

                    if (data.Data) {
                        if (isBlacklist) {
                            $scope.BlacklistExceptions = $scope.BlacklistExceptions || [];
                            var hardwareIDs = $scope.BlacklistExceptions.map(function (x) { return x.HardwareID; });
                            var filteredData = data.Data.filter(function (f) { return hardwareIDs.indexOf(f) === -1 });
                            for (var i = 0; i < filteredData.length; i++) {
                                $scope.BlacklistExceptions.push(filteredData[i]);
                            }
                        }
                        else {
                            $scope.WhitelistExceptions = $scope.WhitelistExceptions || [];
                            var hardwareIDs = $scope.WhitelistExceptions.map(function (x) { return x.HardwareID; });
                            var filteredData = data.Data.filter(function (f) { return hardwareIDs.indexOf(f) === -1 });
                            for (var i = 0; i < filteredData.length; i++) {
                                $scope.WhitelistExceptions.push(filteredData[i]);
                            }
                        }
                        $scope.$apply();
                    }
                }
                else
                {
                    showUiMsg("card", "critical", promptsStrings.importCustomExceptionListFailed, "", "");
                    console.log("importCustomExceptionList failed: " + (data ? data.ErrorMsg : "undefined"));
                }

                if (isBlacklist)
                    $("#importCustomBlacklistFile").val("");
                else
                    $("#importCustomWhitelistFile").val("");

                hidePageContentLoader();
            },
            error: function (xhr, ajaxOptions, thrownError) {
                showUiMsg("card", "critical", promptsStrings.importCustomExceptionListFailed, "", "");

                $("#importCustomWhitelistFile").val("");
                hidePageContentLoader();

                console.log("importCustomExceptionList failed: " + thrownError);
            }
        });
    }
    catch (err) {
        showUiMsg("card", "critical", promptsStrings.importCustomExceptionListFailed, "", "");
        hidePageContentLoader();

        console.log("importCustomExceptionList failed: " + err);
    }

    return false;
}

function ExportEndPointControlPolicy() {
    var grpGuid = angularSEP.Scope[angularSEP.ControllerECGroupProtectionPolicy].GroupGuid;
    downloadURL(ActionURLS.EndPointControlPolicy.DownloadGroupPolicySettings + "?groupGuid=" + grpGuid);
}


////////////////////////////////////////////////////////////////////////////////////////////
///////////////////// AngularJS controllers initialization and setup ///////////////////////
////////////////////////////////////////////////////////////////////////////////////////////

// this function updates all the fields of the first parameter from the fields of the second
// parameter.
function updateEndPointControlPolicyRule(policyRule, updatedPolRule)
{
    if (!policyRule || !updatedPolRule) return;

    policyRule.Guid = updatedPolRule.Guid;
    policyRule.RuleName = updatedPolRule.RuleName;
    policyRule.RuleDescription = updatedPolRule.RuleDescription;
    policyRule.RulePriority = updatedPolRule.RulePriority;
    policyRule.IsDefaultRule = updatedPolRule.IsDefaultRule;
    policyRule.PolicyUsers = [];
    for (var i = 0; i < updatedPolRule.PolicyUsers.length; i++) {
        policyRule.PolicyUsers.push({
            SID: updatedPolRule.PolicyUsers[i].SID,
            UserName: updatedPolRule.PolicyUsers[i].UserName,
            Name: updatedPolRule.PolicyUsers[i].Name,
            IsGroup: updatedPolRule.PolicyUsers[i].IsGroup,
            UserDescription: updatedPolRule.PolicyUsers[i].UserDescription
        });
    }
    
    policyRule.PowerUsers = [];
    for (var i = 0; i < updatedPolRule.PowerUsers.length; i++) {
        policyRule.PowerUsers.push({
            SID: updatedPolRule.PowerUsers[i].SID,
            UserName: updatedPolRule.PowerUsers[i].UserName,
            Name: updatedPolRule.PowerUsers[i].Name,
            IsGroup: updatedPolRule.PowerUsers[i].IsGroup,
            UserDescription: updatedPolRule.PowerUsers[i].UserDescription
        });
    }

    policyRule.FloppyDisksAccess = updatedPolRule.FloppyDisksAccess;
    policyRule.CdDvDsAccess = updatedPolRule.CdDvDsAccess;
    policyRule.StorageDevicesAccess = updatedPolRule.StorageDevicesAccess;
    policyRule.PrintersAccess = updatedPolRule.PrintersAccess;
    policyRule.PdaDevicesAccess = updatedPolRule.PdaDevicesAccess;
    policyRule.NetworkAdaptersAccess = updatedPolRule.NetworkAdaptersAccess;
    policyRule.ModemsAccess = updatedPolRule.ModemsAccess;
    policyRule.ImagingDevicesAccess = updatedPolRule.ImagingDevicesAccess;
    policyRule.HumanInterfaceDevicesAccess = updatedPolRule.HumanInterfaceDevicesAccess;
    policyRule.OtherDevicesAccess = updatedPolRule.OtherDevicesAccess;

    policyRule.UsbPortAccess = updatedPolRule.UsbPortAccess;
    policyRule.FirewirePortAccess = updatedPolRule.FirewirePortAccess;
    policyRule.PcmciaPortAccess = updatedPolRule.PcmciaPortAccess;
    policyRule.BluetoothPortAccess = updatedPolRule.BluetoothPortAccess;
    policyRule.SerialAndParallelPortAccess = updatedPolRule.SerialAndParallelPortAccess;
    policyRule.InfraredPortAccess = updatedPolRule.InfraredPortAccess;
    policyRule.SecureDigitalPortAccess = updatedPolRule.SecureDigitalPortAccess;
    policyRule.InternalPortAccess = updatedPolRule.InternalPortAccess;

    policyRule.FileTypeRestriction = updatedPolRule.FileTypeRestriction;
    policyRule.FileTypes = updatedPolRule.FileTypes;

    policyRule.EnableContentAwareness = updatedPolRule.EnableContentAwareness;
    policyRule.ContentTemplates = updatedPolRule.ContentTemplates;

    policyRule.MaxFileSize = updatedPolRule.MaxFileSize;
    policyRule.SearchArchives = updatedPolRule.SearchArchives;
    policyRule.MaxArchiveNestingLevel = updatedPolRule.MaxArchiveNestingLevel;
    policyRule.FileOptionsOperation = updatedPolRule.FileOptionsOperation;

    policyRule.EnableBitLockerEncryptionSupport = updatedPolRule.EnableBitLockerEncryptionSupport;
    policyRule.BitLockerFileRestrictionMode = updatedPolRule.BitLockerFileRestrictionMode;
    policyRule.BitLockerFileRestrictionType = updatedPolRule.BitLockerFileRestrictionType;
    policyRule.BitLockerRestrictedFileTypes = updatedPolRule.BitLockerRestrictedFileTypes;
    policyRule.BitLockerAccessType = updatedPolRule.BitLockerAccessType;

    policyRule.IsVolumeEncryptionEnabled = updatedPolRule.IsVolumeEncryptionEnabled;
    policyRule.VolumeEncryptionOperation = updatedPolRule.VolumeEncryptionOperation;
    policyRule.VolumeEncryptionRecoveryKey = updatedPolRule.VolumeEncryptionRecoveryKey;
    policyRule.VolumeEncyptionTravelerOperation = updatedPolRule.VolumeEncyptionTravelerOperation;
    policyRule.VolumeEncryptionIsPasswordSecurityEnabled = updatedPolRule.VolumeEncryptionIsPasswordSecurityEnabled;
    policyRule.VolumeEncryptionMinimumPasswordLength = updatedPolRule.VolumeEncryptionMinimumPasswordLength;
    policyRule.VolumeEncryptionAlgorithm = updatedPolRule.VolumeEncryptionAlgorithm;

    // There are two types of encryption. If any of them are enabled, then encryption is enabled. Otherwise encryption is disabled.
    // This field is for convenience of using in UI. It will not be saved in database.
    policyRule.EnableEncryption = policyRule.IsVolumeEncryptionEnabled || policyRule.EnableBitLockerEncryptionSupport;

    policyRule.BlacklistedExceptionsMode = updatedPolRule.BlacklistedExceptionsMode;
    policyRule.WhitelistedExceptionsMode = updatedPolRule.WhitelistedExceptionsMode;
    policyRule.CustomBlacklistedExceptions = updatedPolRule.CustomBlacklistedExceptions;
    policyRule.CustomWhitelistedExceptions = updatedPolRule.CustomWhitelistedExceptions;

    policyRule.EnableAlerts = updatedPolRule.EnableAlerts;
    policyRule.NotifyWhenErrorOccurs = updatedPolRule.NotifyWhenErrorOccurs;
    policyRule.NotifyWhenViolationEventsOccurs = updatedPolRule.NotifyWhenViolationEventsOccurs;
    policyRule.NotifyWhenEncryptedDeviceIsMounted = updatedPolRule.NotifyWhenEncryptedDeviceIsMounted;
    policyRule.NotifyWhenBlockedEventOccurs = updatedPolRule.NotifyWhenBlockedEventOccurs;
    policyRule.NotifyWhenAccessEventsOccurs = updatedPolRule.NotifyWhenAccessEventsOccurs;
    policyRule.NotifyAllAdministrators = updatedPolRule.NotifyAllAdministrators;
    policyRule.AlertRecipients = updatedPolRule.AlertRecipients;
}

// initializes the EndPoint Control policy rule's fields to their default values.
function initEndPointControlPolicyRule(policyRule) {
    policyRule.Guid = "";
    policyRule.RuleName = "";
    policyRule.RuleDescription = "";
    policyRule.RulePriority = 1;
    policyRule.IsDefaultRule = false;
    policyRule.PolicyUsers = [];
    policyRule.PowerUsers = [];

    policyRule.FloppyDisksAccess = AccessLevel.Full;
    policyRule.CdDvDsAccess = AccessLevel.Full;
    policyRule.StorageDevicesAccess = AccessLevel.Full;
    policyRule.PrintersAccess = AccessLevel.Full;
    policyRule.PdaDevicesAccess = AccessLevel.Full;
    policyRule.NetworkAdaptersAccess = AccessLevel.Full;
    policyRule.ModemsAccess = AccessLevel.Full;
    policyRule.ImagingDevicesAccess = AccessLevel.Full;
    policyRule.HumanInterfaceDevicesAccess = AccessLevel.Full;
    policyRule.OtherDevicesAccess = AccessLevel.Full;

    policyRule.UsbPortAccess = AccessLevel.Full;
    policyRule.FirewirePortAccess = AccessLevel.Full;
    policyRule.PcmciaPortAccess = AccessLevel.Full;
    policyRule.BluetoothPortAccess = AccessLevel.Full;
    policyRule.SerialAndParallelPortAccess = AccessLevel.Full;
    policyRule.InfraredPortAccess = AccessLevel.Full;
    policyRule.SecureDigitalPortAccess = AccessLevel.Full;
    policyRule.InternalPortAccess = AccessLevel.Full;

    policyRule.FileTypeRestriction = FileFilterRestrictionType.Allow;
    policyRule.FileTypes = [];

    policyRule.EnableContentAwareness = false;
    policyRule.ContentTemplates = [];

    policyRule.MaxFileSize = 104857600;
    policyRule.SearchArchives = false;
    policyRule.MaxArchiveNestingLevel = 10;
    policyRule.FileOptionsOperation = FileOptionsOperation.Ignore;

    policyRule.EnableBitLockerEncryptionSupport = false;
    policyRule.BitLockerFileRestrictionMode = BitLockerFileRestrictionMode.GlobalFileFilter;
    policyRule.BitLockerFileRestrictionType = FileFilterRestrictionType.Allow;
    policyRule.BitLockerRestrictedFileTypes = [];
    policyRule.BitLockerAccessType = BitLockerAccessLevel.Full;

    policyRule.IsVolumeEncryptionEnabled = false;
    policyRule.VolumeEncryptionOperation = VolumeEncryptionOperation.AllInList;
    policyRule.VolumeEncryptionRecoveryKey = "";
    policyRule.VolumeEncyptionTravelerOperation = VolumeEncryptionOperation.AllInList;
    policyRule.VolumeEncryptionIsPasswordSecurityEnabled = true;
    policyRule.VolumeEncryptionMinimumPasswordLength = 6;
    policyRule.VolumeEncryptionAlgorithm = VolumeEncryptionAlgorithm.Aes256;

    policyRule.BlacklistedExceptionsMode = ExceptionListMode.GlobalBlacklistedExceptions;
    policyRule.WhitelistedExceptionsMode = ExceptionListMode.GlobalWhitelistedExceptions;
    policyRule.CustomBlacklistedExceptions = [];
    policyRule.CustomWhitelistedExceptions = [];

    policyRule.EnableAlerts = false;
    policyRule.NotifyWhenErrorOccurs = true;
    policyRule.NotifyWhenViolationEventsOccurs = true;
    policyRule.NotifyWhenEncryptedDeviceIsMounted = true;
    policyRule.NotifyWhenBlockedEventOccurs = true;
    policyRule.NotifyWhenAccessEventsOccurs = true;
    policyRule.NotifyAllAdministrators = true;
    policyRule.AlertRecipients = [];
}

// This function sets the radio buttons and checkboxes states according the policy rule fields.
// This function is needed because the angular binding and icheck manipulation will interrupt and
// the radio buttons' initial status is unchecked for all radio buttons.
function initPolicyRuleCard(policyRule)
{
    var ecPolCardSel = selectorsECPolicy.ECPolicyRuleCard;
    InitialiseTagify(ecPolCardSel);

    $(selectorsECPolicy.CardCloseButton).removeClass('hidden');
    $(selectorsECPolicy.CardApplyDiscardButtons).addClass('hidden');

    $(ecPolCardSel + " #ec-rule-file-types-allow").icheck(policyRule.FileTypeRestriction == 0 ? "checked" : "unchecked");
    $(ecPolCardSel + " #ec-rule-filetypes-block").icheck(policyRule.FileTypeRestriction == 1 ? "checked" : "unchecked");

    $(ecPolCardSel + " #ec-files-ignore-larger").icheck(policyRule.FileOptionsOperation == 0 ? "checked" : "unchecked");
    $(ecPolCardSel + " #ec-files-block-larger").icheck(policyRule.FileOptionsOperation == 1 ? "checked" : "unchecked");

    $(ecPolCardSel + " #encryption-windows-access-full").icheck(policyRule.BitLockerAccessType == 0 ? "checked" : "unchecked");
    $(ecPolCardSel + " #encryption-windows-access-read").icheck(policyRule.BitLockerAccessType == 1 ? "checked" : "unchecked");
    $(ecPolCardSel + " #encryption-windows-access-write").icheck(policyRule.BitLockerAccessType == 2 ? "checked" : "unchecked");

    $(ecPolCardSel + " #encryption-bitlocker-enc").icheck(policyRule.EnableBitLockerEncryptionSupport ? "checked" : "unchecked");
    $(ecPolCardSel + " #encryption-volume-enc").icheck(policyRule.IsVolumeEncryptionEnabled ? "checked" : "unchecked");

    $(ecPolCardSel + " #encryption-windows-same").icheck(policyRule.BitLockerFileRestrictionMode == 0 ? "checked" : "unchecked");
    $(ecPolCardSel + " #encryption-windows-allow").icheck(policyRule.BitLockerFileRestrictionMode == 1 &&
                                                          policyRule.BitLockerFileRestrictionType == 0 ? "checked" : "unchecked");
    $(ecPolCardSel + " #encryption-windows-block").icheck(policyRule.BitLockerFileRestrictionMode == 1 &&
                                                          policyRule.BitLockerFileRestrictionType == 1 ? "checked": "unchecked");

    $(ecPolCardSel + " #ec-policy-blacklist-global").icheck(
        policyRule.BlacklistedExceptionsMode == ExceptionListMode.GlobalBlacklistedExceptions ? "checked" : "unchecked");
    $(ecPolCardSel + " #ec-policy-blacklist-custom").icheck(
        policyRule.BlacklistedExceptionsMode == ExceptionListMode.CustomBlacklistedExceptions ? "checked" : "unchecked");

    $(ecPolCardSel + " #ec-policy-whitelist-global").icheck(
        policyRule.WhitelistedExceptionsMode == ExceptionListMode.GlobalWhitelistedExceptions ? "checked" : "unchecked");
    $(ecPolCardSel + " #ec-policy-whitelist-custom").icheck(
        policyRule.WhitelistedExceptionsMode == ExceptionListMode.CustomWhitelistedExceptions ? "checked" : "unchecked");

    // Notifications check boxes
    var notifCheckBoxes = [
        { selector: " #notify-agent-error-events", isChecked: policyRule.NotifyWhenErrorOccurs },
        { selector: " #notify-violation-events", isChecked: policyRule.NotifyWhenViolationEventsOccurs },
        { selector: " #notify-encrypted-mount-events", isChecked: policyRule.NotifyWhenEncryptedDeviceIsMounted },
        { selector: " #notify-blocked-events", isChecked: policyRule.NotifyWhenBlockedEventOccurs },
        { selector: " #notify-access-events", isChecked: policyRule.NotifyWhenAccessEventsOccurs },
        { selector: " #ec-notify-all-admins", isChecked: policyRule.NotifyAllAdministrators },
    ];

    for (var i = 0; i < notifCheckBoxes.length; i++) {
        $(ecPolCardSel + notifCheckBoxes[i].selector).icheck(notifCheckBoxes[i].isChecked ? "checked" : "unchecked");
    }

    if (ecAlertRecipientsTagify) {
        var count = ecAlertRecipientsTagify.tagify('containerDiv').children("span").length;
        for (var i = 0; i < count; i++) {
            ecAlertRecipientsTagify.tagify('remove');
        }
    }
    else {
        try {
            ecAlertRecipientsTagify = $(selectorsECPolicy.ECPolicyRuleCard + " input.tagify-input").tagify({
                    addTagPrompt: commonStrings.addRecipients,
                    addTagOnBlur: true,
                    allowDuplicates: false,
                    callbackAdding: ValidateEmailTagify
            });
        }
        catch (err) {
            ecAlertRecipientsTagify = null;
            console.log("Failed tagifying element" + $(this)[0].outerHTML);
        }
    }
}

function setupControllerECGroupPolicyRule($scope, policy, globalBlacklist, globalWhitelist) {
    var isNewPolicyRule = !policy;

    var newPolicy = {};

    if (policy) {
        updateEndPointControlPolicyRule(newPolicy, policy);
    }
    else {
        initEndPointControlPolicyRule(newPolicy);
    }

    // The policy is assigned to the scope's PolicyRule variable. This way we don't need to convert back
    // and forth when loading and saving. We can just JSON.stringify the PolicyRule object and send to
    // server side.
    $scope.PolicyRule = newPolicy;
    $scope.isNewPolicyRule = isNewPolicyRule;

    var convertedSize = getMaxFileSizeAndSizeType(newPolicy.MaxFileSize);
    $scope.PolicyRule.MaxFileSize = convertedSize.MaxSize;
    $scope.MaxFileSizeDesignation = convertedSize.SizeType;

    setMaxFileSizeDesignation($scope.MaxFileSizeDesignation);

    $scope.GlobalBlacklistedExceptions = globalBlacklist ? globalBlacklist : [];
    $scope.GlobalWhitelistedExceptions = globalWhitelist ? globalWhitelist : [];

    $scope.newPolicyUserSID = "";

    // call the functions to setup and create the devices and ports access level collections
    $scope.createPortsAccessLevel();
    $scope.createDevicesAccessLevel();

    $scope.setGlobalCustomExceptionLists();

    $scope.allUsers = [];

    initPolicyRuleCard(newPolicy);
}

function initialiseControllerECGroupPolicyRule(container) {
    var ctrlName = angularSEP.ControllerECGroupPolicyRule;
    if (angularSEP.InitialiseController(ctrlName)) {
        var $scope = angularSEP.Scope[ctrlName];

        $scope.MaxFileSizeDesignation = "mbs";
        $scope.newPolicyUserSID = "";
        $scope.scopeChangesWatcher = null;
        $scope.searchingADUsersInProgress = false;
        $scope.searchingFileTypeInProgress = false;
        $(selectorsECPolicy.AddPolicyFileTypeInput).val("");
        $scope.PolicyFileType = '';
        $scope.FileTypeFilterAutocompleteOpen = false;

        ///////////////////////////////////////////////////////////////////////////
        ////////////////////////////////// Common /////////////////////////////////
        ///////////////////////////////////////////////////////////////////////////
        $scope.deviceCategories = [
            { id: 0, text: "Floppy Disks" },
            { id: 1, text: "CD/DVD" },
            { id: 2, text: "Storage Devices" },
            { id: 3, text: "Printers" },
            { id: 4, text: "PDA Devices" },
            { id: 5, text: "Network Adapters" },
            { id: 6, text: "Modems" },
            { id: 7, text: "Imaging Devices" },
            { id: 8, text: "Human Interface Devices" },
            { id: 9, text: "Other Devices" }
        ];

        $scope.connectivityPorts = [
            { id: 0, text: "USB" },
            { id: 1, text: "Firewire" },
            { id: 2, text: "PCMCIA" },
            { id: 3, text: "Bluetooth" },
            { id: 4, text: "Serial And Parallel" },
            { id: 5, text: "Infrared" },
            { id: 6, text: "Secure Digital (SD)" },
            { id: 7, text: "Internal" }
        ];

        $scope.createDevicesAccessLevel = function() {
            var accessLvls = [];
            accessLvls.push({ id: 0, accessType: $scope.PolicyRule.FloppyDisksAccess });
            accessLvls.push({ id: 1, accessType: $scope.PolicyRule.CdDvDsAccess });
            accessLvls.push({ id: 2, accessType: $scope.PolicyRule.StorageDevicesAccess });
            accessLvls.push({ id: 3, accessType: $scope.PolicyRule.PrintersAccess });
            accessLvls.push({ id: 4, accessType: $scope.PolicyRule.PdaDevicesAccess });
            accessLvls.push({ id: 5, accessType: $scope.PolicyRule.NetworkAdaptersAccess });
            accessLvls.push({ id: 6, accessType: $scope.PolicyRule.ModemsAccess });
            accessLvls.push({ id: 7, accessType: $scope.PolicyRule.ImagingDevicesAccess });
            accessLvls.push({ id: 8, accessType: $scope.PolicyRule.HumanInterfaceDevicesAccess });
            accessLvls.push({ id: 9, accessType: $scope.PolicyRule.OtherDevicesAccess });

            $scope.devicesAccessLevel = accessLvls;
        }

        $scope.processDevicesAccessLevels = function () {
            $scope.PolicyRule.FloppyDisksAccess = $scope.devicesAccessLevel[0].accessType;
            $scope.PolicyRule.CdDvDsAccess = $scope.devicesAccessLevel[1].accessType;
            $scope.PolicyRule.StorageDevicesAccess = $scope.devicesAccessLevel[2].accessType;
            $scope.PolicyRule.PrintersAccess = $scope.devicesAccessLevel[3].accessType;
            $scope.PolicyRule.PdaDevicesAccess = $scope.devicesAccessLevel[4].accessType;
            $scope.PolicyRule.NetworkAdaptersAccess = $scope.devicesAccessLevel[5].accessType;
            $scope.PolicyRule.ModemsAccess = $scope.devicesAccessLevel[6].accessType;
            $scope.PolicyRule.ImagingDevicesAccess = $scope.devicesAccessLevel[7].accessType;
            $scope.PolicyRule.HumanInterfaceDevicesAccess = $scope.devicesAccessLevel[8].accessType;
            $scope.PolicyRule.OtherDevicesAccess = $scope.devicesAccessLevel[9].accessType;
        }

        $scope.createPortsAccessLevel = function() {
            var accessLvls = [];
            accessLvls.push({ id: 0, accessType: $scope.PolicyRule.UsbPortAccess });
            accessLvls.push({ id: 1, accessType: $scope.PolicyRule.FirewirePortAccess });
            accessLvls.push({ id: 2, accessType: $scope.PolicyRule.PcmciaPortAccess });
            accessLvls.push({ id: 3, accessType: $scope.PolicyRule.BluetoothPortAccess });
            accessLvls.push({ id: 4, accessType: $scope.PolicyRule.SerialAndParallelPortAccess });
            accessLvls.push({ id: 5, accessType: $scope.PolicyRule.InfraredPortAccess });
            accessLvls.push({ id: 6, accessType: $scope.PolicyRule.SecureDigitalPortAccess });
            accessLvls.push({ id: 7, accessType: $scope.PolicyRule.InternalPortAccess });

            $scope.portsAccessLevel = accessLvls;
        }

        $scope.processPortsAccessLevels = function () {
            $scope.PolicyRule.UsbPortAccess = $scope.portsAccessLevel[0].accessType;
            $scope.PolicyRule.FirewirePortAccess = $scope.portsAccessLevel[1].accessType;
            $scope.PolicyRule.PcmciaPortAccess = $scope.portsAccessLevel[2].accessType;
            $scope.PolicyRule.BluetoothPortAccess = $scope.portsAccessLevel[3].accessType;
            $scope.PolicyRule.SerialAndParallelPortAccess = $scope.portsAccessLevel[4].accessType;
            $scope.PolicyRule.InfraredPortAccess = $scope.portsAccessLevel[5].accessType;
            $scope.PolicyRule.SecureDigitalPortAccess = $scope.portsAccessLevel[6].accessType;
            $scope.PolicyRule.InternalPortAccess = $scope.portsAccessLevel[7].accessType;
        }

        $scope.convertDeviceCategory = function(category) {
            // since id and index are the same we use category as index, but actually this is the id
            return $scope.deviceCategories[category].text;
        }

        $scope.convertConnectivityPort = function(port) {
            // since id and index are the same we use port as index, but actually this is the id
            return $scope.connectivityPorts[port].text;
        }

        // To avoid situations where Hardware ID, Vendor ID, or Product ID takes the entire row.
        // These fields may be longer than the width of the column.
        $scope.GetDisplayableText = function(field, length) {
            if (field == null)
                field = "";
            if (field.length > length)
                return clamp(field, length);
            else
                return field;
        }

        //////////////////////////////////////////////////////////////////
        /////////////////////////// Black List ///////////////////////////
        //////////////////////////////////////////////////////////////////
        $scope.IsBlacklistEditable = true;
        $scope.IsBlacklistItemEditingMode = false;
        $scope.IsBlacklistItemAddingMode = false;

        $scope.blackListHardwareID = "";
        $scope.blackListVendorID = "";
        $scope.blackListProductID = "";
        $scope.blackListDeviceDesc = "";
        $scope.blackListDeviceCategory = $scope.deviceCategories[0].id;

        $scope.BlacklistExceptions = [];

        //////////////////////////////////////////////////////////////////
        /////////////////////////// White List ///////////////////////////
        //////////////////////////////////////////////////////////////////
        $scope.IsWhitelistEditable = true;
        $scope.IsWhitelistItemEditingMode = false;
        $scope.IsWhitelistItemAddingMode = false;

        $scope.whiteListHardwareID = "";
        $scope.whiteListVendorID = "";
        $scope.whiteListProductID = "";
        $scope.whiteListDeviceDesc = "";
        $scope.whiteListDeviceCategory = $scope.deviceCategories[0].id;

        $scope.WhitelistExceptions = [];

        //////////////////////////////////////////////////////////////////////////////////////
        //////////////////////////// Common to Blacklist and Whitelist ///////////////////////
        //////////////////////////////////////////////////////////////////////////////////////
        $scope.enableExceptionListEditingMode = function(isBlackList, $index) {
            if (isBlackList) {
                $scope.IsBlacklistItemEditingMode = true;
                $scope.IsBlacklistEditable = false;

                indexOfGrpBlacklistExceptionToEdit = $index;

                var exception = $scope.BlacklistExceptions[$index];
                grpBlackListExceptionToEdit = exception;

                $scope.blackListHardwareID = exception.HardwareID;
                $scope.blackListVendorID = exception.VendorID;
                $scope.blackListProductID = exception.ProductID;
                $scope.blackListDeviceDesc = exception.Description;
                $scope.blackListDeviceCategory = $scope.deviceCategories[exception.Category];
            } else {
                $scope.IsWhitelistItemEditingMode = true;
                $scope.IsWhitelistEditable = false;

                indexOfGrpWhitelistExceptionToEdit = $index;

                var exception = $scope.WhitelistExceptions[$index];
                grpWhiteListExceptionToEdit = exception;

                $scope.whiteListHardwareID = exception.HardwareID;
                $scope.whiteListVendorID = exception.VendorID;
                $scope.whiteListProductID = exception.ProductID;
                $scope.whiteListDeviceDesc = exception.Description;
                $scope.whiteListDeviceCategory = $scope.deviceCategories[exception.Category];
            }
        }

        $scope.enableExceptionListAddingMode = function(isBlackList) {
            if (isBlackList) {
                $scope.IsBlacklistItemAddingMode = true;
                $scope.IsBlacklistEditable = false;
            } else {
                $scope.IsWhitelistItemAddingMode = true;
                $scope.IsWhitelistEditable = false;
            }
        }

        $scope.enableExceptionListNormalMode = function(isBlackList) {
            if (isBlackList) {
                $scope.IsBlacklistItemAddingMode = false;
                $scope.IsBlacklistItemEditingMode = false;
                $scope.IsBlacklistEditable = true;

                $scope.blackListHardwareID = "";
                $scope.blackListVendorID = "";
                $scope.blackListProductID = "";
                $scope.blackListDeviceDesc = "";
                $scope.blackListDeviceCategory = 0;
            } else {
                $scope.IsWhitelistItemAddingMode = false;
                $scope.IsWhitelistItemEditingMode = false;
                $scope.IsWhitelistEditable = true;

                $scope.whiteListHardwareID = "";
                $scope.whiteListVendorID = "";
                $scope.whiteListProductID = "";
                $scope.whiteListDeviceDesc = "";
                $scope.whiteListDeviceCategory = 0;
            }
        }

        $scope.deleteCustomException = function(isBlackList, $index) {
            showPrompt('prm-remove-row');

            $("#mngDev-Dlg-OK").off("click");
            $("#mngDev-Dlg-OK").on("click", function (event) {

                if (isBlackList) {
                    $scope.BlacklistExceptions.splice($index, 1);
                }
                else if (!isBlackList) {
                    $scope.WhitelistExceptions.splice($index, 1);
                }

                $scope.$digest();

                $("#mngDev-Dlg-OK").off("click");
            });
        }

        $scope.addEditDeviceException = function (isBlacklist) {
            var newException = isBlacklist ?
                        {
                            HardwareID: $scope.blackListHardwareID.trim(),
                            VendorID: $scope.blackListVendorID,
                            ProductID: $scope.blackListProductID,
                            Description: $scope.blackListDeviceDesc.trim(),
                            Category: $scope.blackListDeviceCategory.id
                        } :
                        {
                            HardwareID: $scope.whiteListHardwareID.trim(),
                            VendorID: $scope.whiteListVendorID,
                            ProductID: $scope.whiteListProductID,
                            Description: $scope.whiteListDeviceDesc.trim(),
                            Category: $scope.whiteListDeviceCategory.id
                        };

            if (newException.HardwareID.length == 0) {
                showUiMsg("card", "critical", ECPolicyStr.HardwareIDEmpty, "", "");
                return;
            }

            if (isBlacklist) {
                if ($scope.IsBlacklistItemAddingMode) {
                    var blackListExceptions = $scope.BlacklistExceptions;

                    for (var i = 0; i < blackListExceptions.length; i++) {
                        if (blackListExceptions[i].HardwareID.trim() == newException.HardwareID.trim()) {
                            showUiMsg("card", "critical", ECPolicyStr.HardwareAlreadyIncluded, "", "");
                            return;
                        }
                    }
                }
            } else {
                if ($scope.IsWhitelistItemAddingMode) {
                    var whiteListExceptions = $scope.WhitelistExceptions;

                    for (var i = 0; i < whiteListExceptions.length; i++) {
                        if (whiteListExceptions[i].HardwareID.trim() == newException.HardwareID.trim()) {
                            showUiMsg("card", "critical", ECPolicyStr.HardwareAlreadyIncluded, "", "");
                            return;
                        }
                    }
                }
            }

            $.ajax({
                type: 'POST',
                dataType: 'json',
                processData: false,
                async: false,
                contentType: "application/json; charset=utf-8",
                data: JSON.stringify({ hardwareID: newException.HardwareID }),
                url: ActionURLS.EndPointControlPolicy.ParseHardwareID,
                success: function (result) {

                    if (result.Success == 'OK') {
                        newException.VendorID = result.HardwareInfo.VendorID;
                        newException.ProductID = result.HardwareInfo.ProductID;

                        if (isBlacklist) {
                            if ($scope.IsBlacklistItemAddingMode) {
                                $scope.BlacklistExceptions.push(newException);
                            } else {
                                $scope.BlacklistExceptions[indexOfGrpBlacklistExceptionToEdit] = newException;
                            }
                        } else {
                            if ($scope.IsWhitelistItemAddingMode) {
                                $scope.WhitelistExceptions.push(newException);
                            } else {
                                $scope.WhitelistExceptions[indexOfGrpWhitelistExceptionToEdit] = newException;
                            }
                        }

                        $scope.enableExceptionListNormalMode(isBlacklist);
                        $scope.$digest();
                    }
                    else {
                        showUiMsg("card", "critical", ECPolicyStr.InvalidHardwareID, "", "");
                    }
                },
                error: function (xhr, ajaxOptions, thrownError) {
                    console && console.log("addEditListException failed: " + thrownError);

                    $scope.enableExceptionListNormalMode(isBlacklist);
                    $scope.$digest();
                }
            });
        }

        $scope.setGlobalExceptionsList = function(isBlacklist) {
            if (isBlacklist) {
                $scope.PolicyRule.BlacklistedExceptionsMode = ExceptionListMode.GlobalBlacklistedExceptions;

                $scope.BlacklistExceptions = $scope.GlobalBlacklistedExceptions;
            }
            else {
                $scope.PolicyRule.WhitelistedExceptionsMode = ExceptionListMode.GlobalWhitelistedExceptions;

                $scope.WhitelistExceptions = $scope.GlobalWhitelistedExceptions;
            }
        }

        $scope.setCustomExceptionsList = function(isBlacklist) {
            if (isBlacklist) {
                $scope.PolicyRule.BlacklistedExceptionsMode = ExceptionListMode.CustomBlacklistedExceptions;

                $scope.BlacklistExceptions = $scope.PolicyRule.CustomBlacklistedExceptions;
            }
            else {
                $scope.PolicyRule.WhitelistedExceptionsMode = ExceptionListMode.CustomWhitelistedExceptions;

                $scope.WhitelistExceptions = $scope.PolicyRule.CustomWhitelistedExceptions;
            }
        }
        
        $scope.setGlobalCustomExceptionLists = function() {
            $scope.PolicyRule.WhitelistedExceptionsMode == ExceptionListMode.GlobalWhitelistedExceptions
                ? $scope.setGlobalExceptionsList(false)
                : $scope.setCustomExceptionsList(false);

            $scope.PolicyRule.BlacklistedExceptionsMode == ExceptionListMode.GlobalBlacklistedExceptions
                ? $scope.setGlobalExceptionsList(true)
                : $scope.setCustomExceptionsList(true);
        }

        //////////////////////////////////////////////////////////////////////////////////////
        /////////////////////////////////// Users /////////////////////////////////////
        $scope.deletePolicyUser = function (user) {
            var index = -1;
            for (var i = 0; i < $scope.PolicyRule.PolicyUsers.length; i++) {
                if (user.SID == $scope.PolicyRule.PolicyUsers[i].SID) {
                    index = i;
                    break;
                }
            }

            $scope.PolicyRule.PolicyUsers.splice(index, 1);
        }

        $scope.addNewPolicyFileType = function () {
            if (!$(selectorsECPolicy.AddPolicyFileTypeInput).val() &&
                !$scope.FileTypeFilterAutocompleteOpen)
            {
                $scope.FileTypeFilterAutocompleteOpen = true;
                $(selectorsECPolicy.AddPolicyFileTypeInput).autocomplete('search', ' ');
                $(selectorsECPolicy.AddPolicyFileTypeInput).focus();
                return;
            }
            else if ($scope.FileTypeFilterAutocompleteOpen) {
                $scope.FileTypeFilterAutocompleteOpen = false;
                $(selectorsECPolicy.AddPolicyFileTypeInput).autocomplete('close');
                return;
            }

            // Check to make sure it is not already added. Retrieve file type, equal to selected file type.
            var data = $scope.PolicyRule.FileTypes.filter(function (f) {
                return f.Extension === $scope.newFileType.Extension &&
                        f.Description === $scope.newFileType.Description;
            });
            
            // If file type already exists in the list of added file types, just return.
            if (data && data.length > 0) {
                return;
            }

            $scope.PolicyRule.FileTypes.push($scope.newFileType);
            $(selectorsECPolicy.AddPolicyFileTypeInput).val('');
            $scope.PolicyFileType = '';
        }

        // when the file type input loses focus, we should reset the button which is on the right
        // side of the file type input.
        $(selectorsECPolicy.AddPolicyFileTypeInput).blur(function () {
            setTimeout(function () {
                $scope.FileTypeFilterAutocompleteOpen = false;
                $scope.$digest();
            }, 200);
        });

        $scope.deletePolicyFileTypes = function (fileType) {
            var index = $scope.PolicyRule.FileTypes.indexOf(fileType);
            $scope.PolicyRule.FileTypes.splice(index, 1);
        }


        $scope.addNewPolicyUser = function() {
            if ($(selectorsECPolicy.AddPolicyUserInput).val() == "") {
                alert(ECPolicyStr.TextfieldIsEmpty);
                return;
            }

            for (var i = 0; i < $scope.PolicyRule.PolicyUsers.length; i++) {
                if ($scope.PolicyRule.PolicyUsers[i].SID == $scope.newPolicyUserSID) {
                    $scope.newPolicyUserSID = "";

                    $(selectorsECPolicy.AddPolicyUserInput).val("");

                    alert(ECPolicyStr.UserAlreadyAddedToList);

                    return;
                }
            }

            var added = false;
            for (var i = 0; i < $scope.allUsers.length && !added; i++) {
                if ($scope.allUsers[i].SID == $scope.newPolicyUserSID) {
                    $scope.PolicyRule.PolicyUsers.push($scope.allUsers[i]);
                    
                    added = true;
                }
            }

            if (!added) alert(ECPolicyStr.TypedTextNotMatchAnyUsername);

            $scope.newPolicyUserSID = "";

            $(selectorsECPolicy.AddPolicyUserInput).val("");
        }

        /////////////////////////////////////////////////////////////////////////////////////
        /////////////////////////////// autocompletes ///////////////////////////////////////

        
        $(selectorsECPolicy.AddPolicyFileTypeInput).autocomplete({
            source: function (request, response) {
                var filter = request.term.trim();
                var data = null;
                if (!filter) {
                    data = globalAllFileTypes.FileTypes;
                }
                else {
                    data = globalAllFileTypes.FileTypes.filter(function (x) {
                        return x.Extension.indexOf(filter) !== -1;
                    });
                }
                    
                response(
                    $.map(data, function (fileType) {
                        return {
                            label: fileType.Extension + '   -   ' + fileType.Description,
                            value: fileType
                        };
                    }));
            },
            select: function (event, ui) {
                $scope.newFileType = ui.item.value;
                $scope.PolicyFileType = ui.item.label;
                $scope.$digest();

                $(this).val(ui.item.label.replace('   -   ', ' - '));

                return false;
            },
            focus: function (event, ui) {
                $scope.newFileType = ui.item.value;
                $scope.PolicyFileType = ui.item.label;
                $scope.$digest();

                $(this).val(ui.item.label.replace('   -   ', ' - '));

                return false;
            },
            open: function () {
                var targetWidth = $(this).outerWidth();
                $(".ui-autocomplete.ui-menu").css("width", targetWidth + "px");
            }
        });

        $(selectorsECPolicy.AddPolicyUserInput).autocomplete({
            source: function (request, response)
            {
                var groupGuid = angularSEP.Scope[angularSEP.ControllerECGroupProtectionPolicy].GroupGuid;
                $scope.searchingADUsersInProgress = true;
                $scope.$digest();

                $(selectorsECPolicy.AddPolicyUserInput).prop('readonly', true);

                $.ajax({
                    type: 'GET',
                    dataType: 'json',
                    async: true,
                    contentType: "application/json; charset=utf-8",
                    url: ActionURLS.SearchForUser.SearchUser,
                    data: { groupGuid: groupGuid, pattern: '*' + request.term + '*' }, // *SEARCH-TERM*
                    success: function (result)
                    {
                        $(selectorsECPolicy.AddPolicyUserInput).prop('readonly', false);

                        if (HandleResult(result, "SearchUser", "content", "critical", result.ErrorMsg, undefined, function () {
                            $scope.searchingADUsersInProgress = false;
                            $scope.$digest();
                        }))
                        {
                            $scope.allUsers = result.Users;
                            $scope.searchingADUsersInProgress = false;
                            $scope.$digest(); // apply the changes to the scope, since the changes are done through JavaScript code.

                            response($.map(result.Users, function (user) { return { label: user.UserName, value: user.SID }; }));
                        }
                    },
                    error: function (xhr, ajaxOptions, thrownError)
                    {
                        $(selectorsECPolicy.AddPolicyUserInput).prop('readonly', false);

                        $scope.allUsers = [];
                        $scope.searchingADUsersInProgress = false;
                        $scope.$digest();

                        if (xhr.statusText == "abort")
                            return;

                        HandleAjaxError(xhr,
                            ajaxOptions,
                            thrownError,
                            "content",
                            "SearchUser",
                            ECPolicyStr.GettingUsersFailed);
                    }
                });
            },
            select: function (event, ui)
            {
                $scope.newPolicyUserSID = ui.item.value;
                $scope.$digest();

                $(this).val(ui.item.label);

                return false;
            },
            open: function ()
            {
                var targetWidth = $(this).outerWidth();
                $(".ui-autocomplete.ui-menu").css("width", targetWidth + "px");
            },
            minLength: 3,
            delay: 900 // 900 milliseconds delay after last typed character. user have enough time to type next one (for slow typers)
        });

        //////////////////////////////////////////////////////////////////////////////////////
        //////////////////////////////////// File Types //////////////////////////////////////
        $scope.addFileTypeRestriction = function (promptClass) {

            showPrompt(promptClass);
            
            $("#mngDev-Dlg-OK").off("click");
            $("#mngDev-Dlg-OK").on("click", function (event) {

                var indStr = $(selPrompts.allFileTypesSelect + ' a.current.selected-option').parent('li').attr('index');

                hidePrompt();

                var index = parseInt(indStr);

                var fileType = globalAllFileTypes.FileTypes[index];

                $scope.PolicyRule.FileTypes.push(fileType);
                $scope.$digest(); // because the changes are made in JavaScript code

                $("#mngDev-Dlg-OK").off("click");
            });
        }

        $scope.deleteFileType = function ($index, targetPrompt) {
            showPrompt(targetPrompt);
            
            $("#mngDev-Dlg-OK").off("click");
            $("#mngDev-Dlg-OK").on("click", function (event) {
                $scope.PolicyRule.FileTypes.splice($index, 1);
                $scope.$digest();

                $("#mngDev-Dlg-OK").off("click");
            });
        }

        //////////////////////////////////////////////////////////////////////////////////////
        //////////////////////////////////// File Types //////////////////////////////////////
        $scope.deleteContentTemplate = function (index, promptClass) {
            $scope.PolicyRule.ContentTemplates.splice(index, 1);
        }

        $scope.addContentTemplates = function(promptClass){
            showPrompt(promptClass);

            $("#mngDev-Dlg-OK").off("click");
            $("#mngDev-Dlg-OK").on("click", function (event) {

                var templateGuid = $(selPrompts.contentTemplateGuidInput).val();

                hidePrompt();

                $.ajax({
                    type: 'GET',
                    dataType: 'json',
                    async: true,
                    contentType: "application/json; charset=utf-8",
                    url: ActionURLS.EndPointControlPolicy.GetContentAwarenessTemplate,
                    data: { templateGuid: templateGuid },
                    success: function (result) {
                        if (HandleResult(result, "GetContentAwarenessTemplate", "content", "critical", result.ErrorMsg)) {
                            $scope.PolicyRule.ContentTemplates.push(result.Template);
                            $scope.$digest(); // because the changes are made in JavaScript code

                            $(selPrompts.contentTemplateGuidInput).val("");
                            $(selPrompts.contentTemplateNameInput).val("");
                        }
                    },
                    error: function (xhr, ajaxOptions, thrownError) {
                        if (xhr.statusText == "abort")
                            return;

                        HandleAjaxError(xhr,
                            ajaxOptions,
                            thrownError,
                            "content",
                            "GetContentAwarenessTemplate",
                            ECPolicyStr.GettingSelectedContentTemplateInfoFailed);

                        console.log("addContentTemplates failed: " + ECPolicyStr.GettingSelectedContentTemplateInfoFailed);
                    }
                });                

                $("#mngDev-Dlg-OK").off("click");
            });
        }

        /////////////////////// Close/Apply/Discard buttons /////////////////////
        $scope.applyPolicyRuleChanges = function () {
            // Stop watching changes to the policy rule card. It will be activated upon the next launch of the card.
            $scope.scopeChangesWatcher();

            var policyScope = angularSEP.Scope[angularSEP.ControllerECGroupProtectionPolicy];

            // if policy rule name is not entered or no policy rule users selected then prompt
            // the user to enter the name or add policy users, or all the changes will be discarded.
            // Only for default rules an empty list of users is allowed which will be mapped to
            // Domain Users group in Policy Mapper.
            if ((!$scope.PolicyRule.RuleName || $scope.PolicyRule.PolicyUsers.length == 0) &&
                !$scope.PolicyRule.IsDefaultRule)
            {
                // this is to keep the EndPoint Control Policy rule card open and user can edit it.
                $("#mngDev-Dlg-OK").off("click");
                $("#mngDev-Dlg-OK").on("click", function () {
                    hidePrompt();

                    $("#mngDev-Dlg-OK").off("click");
                });

                // if the policy name is not entered then ask the user to give this policy rule a name
                // otherwise discard all the changes and close the EndPoint Control policy rule card.
                if (!$scope.PolicyRule.RuleName) {
                    showPrompt("prm-policy-rule-name");
                }

                // if the user did not add any users to the list of policy users then show the prompt
                // and ask the user to either add policy users or discard all the changes.
                if ($scope.PolicyRule.PolicyUsers.length == 0) {
                    showPrompt("prm-policy-rule-users");
                }

                return;
            }

            // if the user selected to enable encryption then he should either select volume encryption or bitlocker
            // encryption. If he enabled encryption and did not select any of the encryption methods then he should
            // go back and fix it.
            if ($scope.PolicyRule.EnableEncryption &&
                (!$scope.PolicyRule.IsVolumeEncryptionEnabled && !$scope.PolicyRule.EnableBitLockerEncryptionSupport))
            {
                // Now that the user enabled encryption and did not select any of the encryption methods then ask him
                // to fix it..

                // this is to keep the EndPoint Control Policy rule card open and user can edit it.
                $("#mngDev-Dlg-OK").off("click");
                $("#mngDev-Dlg-OK").on("click", function () {
                    hidePrompt();

                    $("#mngDev-Dlg-OK").off("click");
                });

                showPrompt("prm-policy-rule-select-enc-type");

                return;
            }
            else if (!$scope.PolicyRule.EnableEncryption)
            {
                // Device encryption is disabled, so set all volume encryption and bitlocker encryption fields to
                // default values.
                $scope.PolicyRule.EnableBitLockerEncryptionSupport = false;
                $scope.PolicyRule.BitLockerFileRestrictionMode = BitLockerFileRestrictionMode.GlobalFileFilter;
                $scope.PolicyRule.BitLockerFileRestrictionType = FileFilterRestrictionType.Allow;
                $scope.PolicyRule.BitLockerRestrictedFileTypes = [];
                $scope.PolicyRule.BitLockerAccessType = BitLockerAccessLevel.Full;

                $scope.PolicyRule.IsVolumeEncryptionEnabled = false;
                $scope.PolicyRule.VolumeEncryptionOperation = VolumeEncryptionOperation.AllInList;
                $scope.PolicyRule.VolumeEncryptionRecoveryKey = "";
                $scope.PolicyRule.VolumeEncyptionTravelerOperation = VolumeEncryptionOperation.AllInList;
                $scope.PolicyRule.VolumeEncryptionIsPasswordSecurityEnabled = true;
                $scope.PolicyRule.VolumeEncryptionMinimumPasswordLength = 6;
                $scope.PolicyRule.VolumeEncryptionAlgorithm = VolumeEncryptionAlgorithm.Aes256;
            }

            $(selectorsECPolicy.ECPolicyRuleCard).removeClass("current");
            $(selectorsECPolicy.ECPolicyRuleCard).hide();

            $scope.processDevicesAccessLevels();
            $scope.processPortsAccessLevels();
            $scope.PolicyRule.MaxFileSize = convertMaxFileSize($scope.MaxFileSizeDesignation,
                                                                    $scope.PolicyRule.MaxFileSize);

            $scope.PolicyRule.AlertRecipients = [];

            if (!$scope.PolicyRule.NotifyAllAdministrators) {
                var recipientsArr = $(selectorsECPolicy.ECAddRecipients).tagify("serialize").split(",");
                for (var i = 0; i < recipientsArr.length; i++) {
                    if (!recipientsArr[i] && !ValidEmailAddress(recipientsArr[i])) {
                        showUiMsg("card", "critical", promptsStrings.ptcInvalidRec, "", "");
                        return null;
                    }
                    else
                        $scope.PolicyRule.AlertRecipients.push(recipientsArr[i]);
                }
            }

            if ($scope.isNewPolicyRule) {
                var index = -1;
                for (var i = 0; i < policyScope.Policy.PolicyRules.length; i++) {
                    if (policyScope.Policy.PolicyRules[i].IsDefaultRule) {
                        index = i;
                        $scope.PolicyRule.RulePriority = policyScope.Policy.PolicyRules[i].RulePriority;
                        policyScope.Policy.PolicyRules[i].RulePriority++;
                    }
                }

                $scope.PolicyRule.Guid = generateUUID();
                $scope.PolicyRule.IsDefaultRule = false;

                policyScope.Policy.PolicyRules.splice(index, 0, $scope.PolicyRule); // insert at index 'index' which is just above Default Rule
                
                if ($scope.PolicyRule.PolicyUsers) {
                    policyScope.Policy.PolicyRules[index].PolicyUsersCount = $scope.PolicyRule.PolicyUsers.filter(function (f) { return !f.IsGroup }).length;
                    policyScope.Policy.PolicyRules[index].PolicyGroupCount = $scope.PolicyRule.PolicyUsers.filter(function (f) { return f.IsGroup }).length;
                }

                // Allow current executing function to complete, becaue it is applying some changes to policy rule.
                // let all the changes complete, then save.
                setTimeout(SaveGroupECSettings, 10);
            }
            else {
                for (var i = 0; i < policyScope.Policy.PolicyRules.length; i++) {
                    if (policyScope.Policy.PolicyRules[i].Guid === $scope.PolicyRule.Guid) {
                        updateEndPointControlPolicyRule(policyScope.Policy.PolicyRules[i], $scope.PolicyRule);
                        if ($scope.PolicyRule.PolicyUsers) {
                            policyScope.Policy.PolicyRules[i].PolicyUsersCount = $scope.PolicyRule.PolicyUsers.filter(function (f) { return !f.IsGroup }).length;
                            policyScope.Policy.PolicyRules[i].PolicyGroupCount = $scope.PolicyRule.PolicyUsers.filter(function (f) { return f.IsGroup }).length;
                        }

                        // Allow current executing function to complete, becaue it is applying some changes to policy rule.
                        // let all the changes complete, then save.
                        setTimeout(SaveGroupECSettings, 10);
                    }
                }
            }

            angularSEP.Scope[angularSEP.ControllerECGroupProtectionPolicy].$apply();
        }

        // this function will be used by both close button and discard button.
        $scope.closeEditPolicyRuleCard = function () {
            // Stop watching changes to the policy rule card. It will be activated upon the next launch of the card.
            $scope.scopeChangesWatcher();

            $(selectorsECPolicy.ECPolicyRuleCard).removeClass("current");
            $(selectorsECPolicy.ECPolicyRuleCard).hide();
        }

        /////////////////////////////////// Setup the controller /////////////////////////////
        setupControllerECGroupPolicyRule($scope);

        ////////////////////////////////// Apply ////////////////////////////////
        $scope.$apply();
    }
}

function setupControllerECGroupProtectionPolicy($scope, policy, groupGuid) {
    if (!policy) {
        policy = {};
        policy.UserAllowedToModify = false;
        policy.UserAllowedToDisable = false;
        policy.UserAllowedToDefineExceptions = false;

        policy.GroupGuid = groupGuid;
        policy.Guid = "";
        policy.Name = "";
        policy.ServiceType = "EndPointControl";

        policy.Enabled = true;
        policy.ServiceEnabled = false;
        policy.RegisterTrial = false;
        policy.ApplyGroupPolicyEnabledToChildren = true;
        policy.ServiceLicenseStatus = null;
        policy.ChildGroupGuids = [];
        policy.InheritFromParent = true;
        policy.InheritFromParentGuid = "";
        policy.InheritFromParentName = "";

        policy.GlobalBlacklistedDevices = [];
        policy.GlobalWhitelistedDevices = [];

        policy.PolicyRules = [];
    }

    if (groupGuid) {
        $scope.GroupGuid = groupGuid;
        policy.GroupGuid = groupGuid;
    }

    $scope.Policy = policy;

    // calculate the number of groups and users for each policy rule to be shown in
    // policy rules table.
    if (policy) {
        for (var i = 0; i < $scope.Policy.PolicyRules.length; i++) {
            var rule = $scope.Policy.PolicyRules[i];
            
            if (rule.IsDefaultRule) {
                $scope.DefaultPolicyRule = rule;
            }

            var grps = 0;
            var users = 0;
            if (rule.PolicyUsers) {
                for (var j = 0; j < rule.PolicyUsers.length; j++) {
                    if (rule.PolicyUsers[j].IsGroup) grps++;
                    else users++;
                }
            }

            rule.PolicyGroupCount = grps;
            rule.PolicyUsersCount = users;
        }
    }
}

function initialiseControllerECGroupProtectionPolicy(container) {
    var ctrlName = angularSEP.ControllerECGroupProtectionPolicy;
    if (angularSEP.InitialiseController(ctrlName)) {
        var $scope = angularSEP.Scope[ctrlName];

        $scope.movePolicyRuleDown = function(guid) {
            var rule = null;
            for (var i = 0; i < $scope.Policy.PolicyRules.length; i++) {
                if ($scope.Policy.PolicyRules[i].Guid == guid) {
                    rule = $scope.Policy.PolicyRules[i];
                    break;
                }
            }

            var priority = rule.RulePriority;
            var upperRule = null;
            for (var i = 0; i < $scope.Policy.PolicyRules.length; i++) {
                if ($scope.Policy.PolicyRules[i].RulePriority == (priority + 1)) {
                    upperRule = $scope.Policy.PolicyRules[i];

                    upperRule.RulePriority = priority;
                    rule.RulePriority += 1;
                    break;
                }
            }  

            showSaveMsg("content", selSet.saveSettPatchMgmtId, null, SaveGroupECSettings);
        }

        $scope.movePolicyRuleUp = function (guid) {
            var rule = null;
            for (var i = 0; i < $scope.Policy.PolicyRules.length; i++) {
                if ($scope.Policy.PolicyRules[i].Guid == guid) {
                    rule = $scope.Policy.PolicyRules[i];
                    break;
                }
            }

            var priority = rule.RulePriority;
            var lowerRule = null;
            for (var i = 0; i < $scope.Policy.PolicyRules.length; i++) {
                if ($scope.Policy.PolicyRules[i].RulePriority == (priority - 1)) {
                    lowerRule = $scope.Policy.PolicyRules[i];

                    lowerRule.RulePriority = priority;
                    rule.RulePriority -= 1;
                    break;
                }
            }

            showSaveMsg("content", selSet.saveSettPatchMgmtId, null, SaveGroupECSettings);
        }

        $scope.deletePolicyRule = function (guid, targetPrompt) {

            showPrompt(targetPrompt);

            $("#mngDev-Dlg-OK").off("click");
            $("#mngDev-Dlg-OK").on("click", function (event) {
                var ruleIndex = null;
                var targetRule = undefined;
                for (var i = 0; i < $scope.Policy.PolicyRules.length; i++) {
                    if ($scope.Policy.PolicyRules[i].Guid == guid) {
                        ruleIndex = i;
                        break;
                    }
                }

                var priority = $scope.Policy.PolicyRules[ruleIndex].RulePriority;

                // All rules below this rule needs to be updated. Because rules above this rule have higher priority (lower number)
                // and override this rule so they will not be affected by deletion of this rule.
                // But all those rules which are blow this rule need to be updated and their priorities will increase, by decreasing
                // RulePriority number.
                var lowerRules = $.grep($scope.Policy.PolicyRules, function (r) { return r.RulePriority > priority; });

                for (var i = 0; i < lowerRules.length; i++) {
                    lowerRules[i].RulePriority--; // increase priority
                }

                $scope.Policy.PolicyRules.splice(ruleIndex, 1);
                $scope.$digest();

                showSaveMsg("content", selSet.saveSettPatchMgmtId, null, SaveGroupECSettings);

                $("#mngDev-Dlg-OK").off("click");
            });
        }

        $scope.addOrEditPolicyRule = function (isNewPolicyRule, guid) {
            var globalBlacklist = $scope.Policy.GlobalBlacklistedDevices;
            var globalWhitelist = $scope.Policy.GlobalWhitelistedDevices;

            var policy = null;

            if (!isNewPolicyRule) {
                for (var i = 0; i < $scope.Policy.PolicyRules.length; i++) {
                    if ($scope.Policy.PolicyRules[i].Guid == guid) {
                        policy = $scope.Policy.PolicyRules[i];
                        break;
                    }
                }

                if (policy.EnableAlerts && !policy.NotifyAllAdministrators) {
                    for (var i = 0; i < policy.AlertRecipients.length; i++) {
                        $(selectorsECPolicy.ECAddRecipients).tagify('add', policy.AlertRecipients[i])
                    }
                }
            }

            var policyRuleScope = angularSEP.Scope[angularSEP.ControllerECGroupPolicyRule];
            setupControllerECGroupPolicyRule(policyRuleScope, policy, globalBlacklist, globalWhitelist);

            policyRuleScope.$digest();

            /////////////////////////// Watch scope changes /////////////////////////
            // This function hides the close button and shows Apply and Discard buttons
            // upon any change in Editing Policy Rule Card.
            function showApplyAndDiscardButtons() {
                $(selectorsECPolicy.CardCloseButton).addClass('hidden');
                $(selectorsECPolicy.CardApplyDiscardButtons).removeClass('hidden');
            }

            policyRuleScope.scopeChangesWatcher = policyRuleScope.$watch("PolicyRule", function () {
                showApplyAndDiscardButtons();
            });
            /////////////////////////////////////////////////////////////////////////

            $(".ec-policy-rules-card div.open-card-container").off('click');

            $(selectorsECPolicy.AddPolicyUserInput).val("");

            $(selectorsECPolicy.ECPolicyRuleCard).addClass("current");
            $(selectorsECPolicy.ECPolicyRuleCard).show();
        }

        $scope.editPolicyRule = function(guid) {
            $scope.addOrEditPolicyRule(false, guid);
        }

        $scope.addNewPolicyRule = function () {
            $scope.addOrEditPolicyRule(true);
        }

        $scope.checkPolicyUser = function() {
            $scope.checkingPolicyUserInProgress = true;

            $.ajax({
                type: 'POST',
                dataType: 'json',
                processData: false,
                async: true,
                contentType: "application/json; charset=utf-8",
                url: ActionURLS.EndPointControlPolicy.CheckAppliedPolicyToUser,
                data: JSON.stringify({ username: $scope.policyUserNameToCheck, groupGuid: $scope.GroupGuid }),
                success: function (result) {

                    if (HandleResult(result, "CheckAppliedPolicyToUser", "content", "critical", result.ErrorMsg, undefined, function() {
                        $scope.policyUserNameToCheck = "";
                        $scope.checkingPolicyUserInProgress = false;
                        $scope.$digest();
                    })) {

                        $scope.policyUserNameToCheck = "";
                        $scope.appliedPolicy = result.AppliedPolicy;
                        $scope.showPolicyCheckResult = true;
                        $scope.checkingPolicyUserInProgress = false;
                        $scope.$digest(); // apply the changes to the scope, since the changes are done through JavaScript code.
                    }
                },
                error: function (xhr, ajaxOptions, thrownError) {
                    $scope.policyUserNameToCheck = "";
                    $scope.checkingPolicyUserInProgress = false;
                    $scope.$digest();

                    if (xhr.statusText == "abort")
                        return;

                    HandleAjaxError(xhr,
                        ajaxOptions,
                        thrownError,
                        "content",
                        "CheckAppliedPolicyToUser",
                        ECPolicyStr.CheckPolicyUserFailed);
                }
            });

        }

        $scope.clearCheckUserResult = function () {
            $scope.showPolicyCheckResult = false;
            $scope.appliedPolicy = "";
        }

        setupControllerECGroupProtectionPolicy($scope);

        ////////////////////////////////// Apply ////////////////////////////////
        $scope.$apply();
    }
}

function InitialiseGroupEndPointProtectionPolicy(containerSelector) {
    initialiseControllerECGroupProtectionPolicy(containerSelector);
    initialiseControllerECGroupPolicyRule(containerSelector);

    $('.max-file-size').off('select');
    $('.max-file-size').on('select', function (e) {
        var val = $(this).val();
        if (!val || !parseInt(val)) $(this).val(0); // if not a valid integer then making its value 0.
        e.stopPropagation();
    });

    $(containerSelector + " " + selectorsECPolicy.InheritFrmPrntCheckbox).off("ifToggled");
    $(containerSelector + " " + selectorsECPolicy.InheritFrmPrntCheckbox).on("ifToggled", function (e) {
        if ($(this).attr("disabled") == null) {
            showSaveMsg("content", selSet.saveSettPatchMgmtId, null, SaveGroupECSettings);
        }
    });

    // on policy enabled switch
    $(containerSelector).off("click", selectorsECPolicy.SwitchService);
    $(containerSelector).on("click", selectorsECPolicy.SwitchService, function () {
        if ($(selectorsECPolicy.GeneralEnabled).is(":disabled"))
            return false;
        if ($(selectorsECPolicy.GeneralEnabled).is(":checked")) {

            // ask to disable policy for group and/or children if this group has children
            if (angularSEP.Scope[angularSEP.ControllerECGroupProtectionPolicy].Policy.ChildGroupGuids.length > 0)
                showPrompt('prm-policy-child-groups', ["{{SERVICENAME}}", "{{ENABLE-DISABLE}}", "{{ENABLING-DISABLING}}", "{{ENABLING-DISABLING2}}"], [ManageDevicesGeneral.EcName, ManageDevicesGeneral.Disable, ManageDevicesGeneral.Disabling, ManageDevicesGeneral.Disabling]);
            else {
                showSaveMsg("content", selSet.saveSettPatchMgmtId, null, SaveGroupECSettings);
                switchECPolicyCheck();
            }

        } else {

            if (!angularSEP.Scope[angularSEP.ControllerECGroupProtectionPolicy].Policy.ServiceEnabled)
                CheckLicenseGroup(angularSEP.Scope[angularSEP.ControllerECGroupProtectionPolicy].Policy.ServiceLicenseStatus, enableECGroupPolicy);
            else
                enableECGroupPolicy();
        }

        return false;
    });
}